const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MessagesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const messages = await db.messages.create(
      {
        id: data.id || undefined,

        receiver_role: data.receiver_role || null,
        message_type: data.message_type || null,
        content: data.content || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await messages.setSender(data.sender || null, {
      transaction,
    });

    await messages.setReceiver(data.receiver || null, {
      transaction,
    });

    await messages.setSchool(data.school || null, {
      transaction,
    });

    await messages.setSchools(data.schools || null, {
      transaction,
    });

    return messages;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const messagesData = data.map((item, index) => ({
      id: item.id || undefined,

      receiver_role: item.receiver_role || null,
      message_type: item.message_type || null,
      content: item.content || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const messages = await db.messages.bulkCreate(messagesData, {
      transaction,
    });

    // For each item created, replace relation files

    return messages;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const messages = await db.messages.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.receiver_role !== undefined)
      updatePayload.receiver_role = data.receiver_role;

    if (data.message_type !== undefined)
      updatePayload.message_type = data.message_type;

    if (data.content !== undefined) updatePayload.content = data.content;

    updatePayload.updatedById = currentUser.id;

    await messages.update(updatePayload, { transaction });

    if (data.sender !== undefined) {
      await messages.setSender(
        data.sender,

        { transaction },
      );
    }

    if (data.receiver !== undefined) {
      await messages.setReceiver(
        data.receiver,

        { transaction },
      );
    }

    if (data.school !== undefined) {
      await messages.setSchool(
        data.school,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await messages.setSchools(
        data.schools,

        { transaction },
      );
    }

    return messages;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const messages = await db.messages.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of messages) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of messages) {
        await record.destroy({ transaction });
      }
    });

    return messages;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const messages = await db.messages.findByPk(id, options);

    await messages.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await messages.destroy({
      transaction,
    });

    return messages;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const messages = await db.messages.findOne({ where }, { transaction });

    if (!messages) {
      return messages;
    }

    const output = messages.get({ plain: true });

    output.sender = await messages.getSender({
      transaction,
    });

    output.receiver = await messages.getReceiver({
      transaction,
    });

    output.school = await messages.getSchool({
      transaction,
    });

    output.schools = await messages.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.users,
        as: 'sender',

        where: filter.sender
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.sender
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.sender
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.users,
        as: 'receiver',

        where: filter.receiver
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.receiver
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.receiver
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.schools,
        as: 'school',
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.content) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('messages', 'content', filter.content),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.receiver_role) {
        where = {
          ...where,
          receiver_role: filter.receiver_role,
        };
      }

      if (filter.message_type) {
        where = {
          ...where,
          message_type: filter.message_type,
        };
      }

      if (filter.school) {
        const listItems = filter.school.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolId: { [Op.or]: listItems },
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.messages.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('messages', 'content', query),
        ],
      };
    }

    const records = await db.messages.findAll({
      attributes: ['id', 'content'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['content', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.content,
    }));
  }
};
